from power import Power
from src.constants import HOUSE_L, HOUSE_R, ROCK


class Rock(Power):

    instance = None

    @classmethod
    def get_instance(cls):

        if cls.instance is None:
            cls.instance = cls()
        return cls.instance

    def __init__(self):

        Power.__init__(self)

    def point_is_valid(self, point):

        crushable = self.state.terrain_map.point_is_crushable(point)

        return crushable

    def use_power(self, point):
        self.crush_house(point)
        self.add_rock(point)
        self.crush_point(point)

    def crush_house(self, point):
        if self.state.terrain_map.get_tile(point) in (HOUSE_L, HOUSE_R):
            house = filter(lambda x: point in x.get_coords(), self.state.object_list.get_all('mushhouse'))
            assert len(house) == 1
            house[0].destroy_house()

    def crush_point(self, point):

        stopped_water = filter(lambda x: x.coord == point, self.state.object_list.get_all('water'))
        if stopped_water:
            self.obstruct_river(point)

        # destroy all other objects
        crushed = filter(lambda x: x.coord == point, self.state.object_list.objects)
        map(lambda x: x.die(), crushed)

    def add_rock(self, point):

        self.state.terrain_map.set_tile(point, ROCK)
        self.state.map_image.update((point,))
        self.state.path_finding_map.compute()

    def obstruct_river(self, point):

        water = filter(lambda x: x.coord == point, self.state.object_list.get_all('water'))
        for w in water:
            river = w.river
            river.block_river(point)
