

class ObjectList(object):

    def __init__(self, state):

        self.objects = []
        self.state = state
        self.houses_remain = True

    def remove_object(self, obj):
        self.objects.remove(obj)
        self.state.draw_list.remove_from_list(obj, obj.flag)

    def add_object(self, obj):
        self.objects.append(obj)
        self.state.draw_list.add_new(obj, obj.flag)

    def run(self):
        for obj in self.objects:
            obj.run()

    def point_is_blocked(self, point):

        points_blocked_by_object = set(map(lambda x: x.coord, filter(lambda x: x.blocks, self.objects)))
        return point in points_blocked_by_object

    def get_all(self, key):
        if isinstance(key, tuple):
            return filter(lambda x: x.key in key, self.objects)
        else:
            return filter(lambda x: x.key == key, self.objects)
